package chap10.program04

import chap10.program03._

class SimpleParser(lexer: SimpleLexer) {
  var lookahead = lexer.nextToken

  // <式> ::= <数字> + <数字> | <数字> - <数字> | <数字>
  def expression = {
    number
    nextToken match {
      case Token(lexer.OPERATOR, value) =>
        {operator; number} // <数字> + <数字> | <数字> - <数字>
      case Token(lexer.EOF, value) => // <数字>
      case token: Token =>
        throw new Exception("found: " + lookahead +
                            ", but not expected.")
    }
  }
  // + | -
  def operator = nextToken
  // <数字> ::= 0|1|2|3|4|5|6|7|8|9
  def number = matches(lexer.NUMBER)

  def matches(tokenType: String) = {
    if(!lookahead.tokenType.equals(tokenType))
      throw new Exception("found: " + lookahead +
                          ", but expected: " + tokenType)
  }

  def nextToken: Token = {(lookahead = lexer.nextToken); lookahead}
}
