package chap10.program05

import chap10.program03._

class SimpleParser2(lexer: SimpleLexer) {
  var lookahead = lexer.nextToken
  val ir = new IR

  // <式> ::= <数字> + <数字> | <数字> - <数字> | <数字>
  def expression: IR = {
    number
    nextToken match {
      case Token(lexer.OPERATOR, value) =>
        operator(value); number
      case Token(lexer.EOF, value) =>
      case _ => 
        throw new Exception("found: " + lookahead +
                            ", but not expected.")
    }
    ir
  }
  // + | -
  def operator(value: String) = {nextToken; ir.addOperator(value)}
  // <数字> ::= 0|1|2|3|4|5|6|7|8|9
  def number = {matches(lexer.NUMBER);
                ir.addOperand(lookahead.value)}

  def matches(tokenType: String) = {
    if(!lookahead.tokenType.equals(tokenType))
      throw new Exception("found: " + lookahead +
                          ", but expected: " + tokenType)
  }

  def nextToken: Token = {(lookahead = lexer.nextToken); lookahead}
}

