package chap10.program07

import scala.util.parsing.combinator._

class CombinatorParser2 extends JavaTokenParsers {
  def parse(data: String) = parseAll(expression, data)

  // <式> ::= <数字> + <数字> | <数字> - <数字> | <数字>
  def expression: Parser[IR2] =
    (number~"+"~number) ^^ {
      case opr1~p~opr2 => Operator("+", opr1, opr2)} | // IRの生成
    (number~"-"~number) ^^ {
      case opr1~m~opr2 => Operator("-", opr1, opr2)} | // IRの生成
    number

  // <数字> ::= 0|1|2|3|4|5|6|7|8|9
  def number: Parser[IR2] = """[0-9]""".r ^^ {
    n => Number(n.toFloat)} // IRの生成
}
